"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var serverless_1 = __importDefault(require("serverless"));
var mockFactory_1 = require("../../test/mockFactory");
var utils_1 = require("../../test/utils");
var azureApimServicePlugin_1 = require("./azureApimServicePlugin");
jest.mock("../../services/apimService");
var apimService_1 = require("../../services/apimService");
describe("APIM Service Plugin", function () {
    it("is defined", function () {
        expect(azureApimServicePlugin_1.AzureApimServicePlugin).toBeDefined();
    });
    it("can be instantiated", function () {
        var serverless = new serverless_1.default();
        var options = {
            stage: "",
            region: "",
        };
        var plugin = new azureApimServicePlugin_1.AzureApimServicePlugin(serverless, options);
        expect(plugin).not.toBeNull();
    });
    it("calls deploy API and deploy functions", function () { return __awaiter(_this, void 0, void 0, function () {
        var deployApi, deployFunctions, sls, options, plugin;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    deployApi = jest.fn();
                    deployFunctions = jest.fn();
                    apimService_1.ApimService.prototype.deployApi = deployApi;
                    apimService_1.ApimService.prototype.deployFunctions = deployFunctions;
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    sls.service.provider["apim"] = "apim config";
                    options = mockFactory_1.MockFactory.createTestServerlessOptions();
                    plugin = new azureApimServicePlugin_1.AzureApimServicePlugin(sls, options);
                    return [4 /*yield*/, utils_1.invokeHook(plugin, "after:deploy:deploy")];
                case 1:
                    _a.sent();
                    expect(sls.cli.log).toBeCalledWith("Starting APIM service deployment");
                    expect(deployApi).toBeCalled();
                    expect(deployFunctions).toBeCalled();
                    expect(sls.cli.log).lastCalledWith("Finished APIM service deployment");
                    return [2 /*return*/];
            }
        });
    }); });
    it("does not call deploy API or deploy functions when \"apim\" not included in config", function () { return __awaiter(_this, void 0, void 0, function () {
        var deployApi, deployFunctions, sls, options, plugin;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    deployApi = jest.fn();
                    deployFunctions = jest.fn();
                    apimService_1.ApimService.prototype.deployApi = deployApi;
                    apimService_1.ApimService.prototype.deployFunctions = deployFunctions;
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    options = mockFactory_1.MockFactory.createTestServerlessOptions();
                    plugin = new azureApimServicePlugin_1.AzureApimServicePlugin(sls, options);
                    return [4 /*yield*/, utils_1.invokeHook(plugin, "after:deploy:deploy")];
                case 1:
                    _a.sent();
                    expect(sls.cli.log).not.toBeCalled();
                    expect(deployApi).not.toBeCalled();
                    expect(deployFunctions).not.toBeCalled();
                    return [2 /*return*/];
            }
        });
    }); });
});
