"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var axios_mock_adapter_1 = __importDefault(require("axios-mock-adapter"));
var mock_fs_1 = __importDefault(require("mock-fs"));
var path_1 = __importDefault(require("path"));
var mockFactory_1 = require("../test/mockFactory");
var functionAppService_1 = require("./functionAppService");
var armService_1 = require("./armService");
var functionApp_1 = require("../armTemplates/resources/functionApp");
jest.mock("@azure/arm-appservice");
var arm_appservice_1 = require("@azure/arm-appservice");
var armTemplates_1 = require("../models/armTemplates");
jest.mock("@azure/arm-resources");
jest.mock("./azureBlobStorageService");
var azureBlobStorageService_1 = require("./azureBlobStorageService");
var config_1 = __importDefault(require("../config"));
describe("Function App Service", function () {
    var app = mockFactory_1.MockFactory.createTestSite();
    var slsService = mockFactory_1.MockFactory.createTestService();
    var variables = mockFactory_1.MockFactory.createTestVariables();
    var provider = mockFactory_1.MockFactory.createTestAzureServiceProvider();
    var masterKey = "masterKey";
    var authKey = "authKey";
    var syncTriggersMessage = "sync triggers success";
    var deleteFunctionMessage = "delete function success";
    var functions = mockFactory_1.MockFactory.createTestSlsFunctionConfig();
    var functionsResponse = mockFactory_1.MockFactory.createTestFunctionsResponse(functions);
    var baseUrl = "https://management.azure.com";
    var masterKeyUrl = "https://" + app.defaultHostName + "/admin/host/systemkeys/_master";
    var authKeyUrl = "" + baseUrl + app.id + "/functions/admin/token?api-version=2016-08-01";
    var syncTriggersUrl = "" + baseUrl + app.id + "/syncfunctiontriggers?api-version=2016-08-01";
    var listFunctionsUrl = "" + baseUrl + app.id + "/functions?api-version=2016-08-01";
    beforeAll(function () {
        var e_1, _a;
        var axiosMock = new axios_mock_adapter_1.default(axios_1.default);
        // Master Key
        axiosMock.onGet(masterKeyUrl).reply(200, { value: masterKey });
        // Auth Key
        axiosMock.onGet(authKeyUrl).reply(200, authKey);
        // Sync Triggers
        axiosMock.onPost(syncTriggersUrl).reply(200, syncTriggersMessage);
        // List Functions
        axiosMock.onGet(listFunctionsUrl).reply(200, { value: functionsResponse });
        try {
            // Delete Function
            for (var _b = __values(Object.keys(functions)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var funcName = _c.value;
                axiosMock.onDelete("" + baseUrl + app.id + "/functions/" + funcName + "?api-version=2016-08-01")
                    .reply(200, deleteFunctionMessage);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        mock_fs_1.default({
            "app.zip": "contents",
            ".serverless": {
                "serviceName.zip": "contents",
            }
        }, { createCwd: true, createTmp: true });
    });
    beforeEach(function () {
        arm_appservice_1.WebSiteManagementClient.prototype.webApps = {
            get: jest.fn(function () { return app; }),
            deleteFunction: jest.fn(),
        };
        functionAppService_1.FunctionAppService.prototype.sendFile = jest.fn();
    });
    afterEach(function () {
        jest.clearAllMocks();
    });
    afterAll(function () {
        mock_fs_1.default.restore();
    });
    function createService(sls, options) {
        return new functionAppService_1.FunctionAppService(sls || mockFactory_1.MockFactory.createTestServerless({
            service: slsService,
            variables: variables,
        }), options || mockFactory_1.MockFactory.createTestServerlessOptions());
    }
    it("get returns function app", function () { return __awaiter(_this, void 0, void 0, function () {
        var service, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    service = createService();
                    return [4 /*yield*/, service.get()];
                case 1:
                    result = _a.sent();
                    expect(arm_appservice_1.WebSiteManagementClient.prototype.webApps.get)
                        .toBeCalledWith(provider.resourceGroup, functionApp_1.FunctionAppResource.getResourceName(slsService));
                    expect(result).toEqual(app);
                    return [2 /*return*/];
            }
        });
    }); });
    it("get returns null if error occurred", function () { return __awaiter(_this, void 0, void 0, function () {
        var service, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    service = createService();
                    arm_appservice_1.WebSiteManagementClient.prototype.webApps = {
                        get: jest.fn(function () { return { error: { code: "ResourceNotFound" } }; }),
                        deleteFunction: jest.fn(),
                    };
                    return [4 /*yield*/, service.get()];
                case 1:
                    result = _a.sent();
                    expect(arm_appservice_1.WebSiteManagementClient.prototype.webApps.get)
                        .toBeCalledWith(provider.resourceGroup, functionApp_1.FunctionAppResource.getResourceName(slsService));
                    expect(result).toBeNull();
                    return [2 /*return*/];
            }
        });
    }); });
    it("gets master key", function () { return __awaiter(_this, void 0, void 0, function () {
        var service, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    service = createService();
                    return [4 /*yield*/, service.getMasterKey()];
                case 1:
                    result = _a.sent();
                    expect(result).toEqual(masterKey);
                    return [2 /*return*/];
            }
        });
    }); });
    it("deletes function", function () { return __awaiter(_this, void 0, void 0, function () {
        var service, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    service = createService();
                    return [4 /*yield*/, service.deleteFunction(app, Object.keys(functions)[0])];
                case 1:
                    response = _a.sent();
                    expect(response.data).toEqual(deleteFunctionMessage);
                    return [2 /*return*/];
            }
        });
    }); });
    it("syncs triggers", function () { return __awaiter(_this, void 0, void 0, function () {
        var service, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    service = createService();
                    return [4 /*yield*/, service.syncTriggers(app)];
                case 1:
                    result = _a.sent();
                    expect(result.data).toEqual(syncTriggersMessage);
                    return [2 /*return*/];
            }
        });
    }); });
    it("cleans up", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, service, result, functionNames, logCalls, i, functionName;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    service = createService(sls);
                    return [4 /*yield*/, service.cleanUp(app)];
                case 1:
                    result = _a.sent();
                    functionNames = Object.keys(functions);
                    expect(result).toHaveLength(functionNames.length);
                    logCalls = sls.cli.log.mock.calls;
                    for (i = 0; i < functionNames.length; i++) {
                        functionName = functionNames[i];
                        expect(logCalls[i + 1][0]).toEqual("-> Deleting function: " + functionName);
                    }
                    return [2 /*return*/];
            }
        });
    }); });
    it("lists functions", function () { return __awaiter(_this, void 0, void 0, function () {
        var service, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    service = createService();
                    _a = expect;
                    return [4 /*yield*/, service.listFunctions(app)];
                case 1:
                    _a.apply(void 0, [_b.sent()]).toEqual(functionsResponse.map(function (f) { return f.properties; }));
                    return [2 /*return*/];
            }
        });
    }); });
    describe("Deployments", function () {
        var expectedDeployment = {
            parameters: {},
            template: mockFactory_1.MockFactory.createTestArmTemplate(),
        };
        var expectedSite = mockFactory_1.MockFactory.createTestSite();
        beforeEach(function () {
            functionAppService_1.FunctionAppService.prototype.get = jest.fn(function () { return Promise.resolve(expectedSite); });
            armService_1.ArmService.prototype.createDeploymentFromConfig = jest.fn(function () { return Promise.resolve(expectedDeployment); });
            armService_1.ArmService.prototype.createDeploymentFromType = jest.fn(function () { return Promise.resolve(expectedDeployment); });
            armService_1.ArmService.prototype.deployTemplate = jest.fn(function () { return Promise.resolve(null); });
        });
        it("deploys ARM templates with custom configuration", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, site;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        slsService.provider["armTemplate"] = {};
                        service = createService();
                        return [4 /*yield*/, service.deploy()];
                    case 1:
                        site = _a.sent();
                        expect(site).toEqual(expectedSite);
                        expect(armService_1.ArmService.prototype.createDeploymentFromConfig).toBeCalledWith(slsService.provider["armTemplate"]);
                        expect(armService_1.ArmService.prototype.createDeploymentFromType).not.toBeCalled();
                        expect(armService_1.ArmService.prototype.deployTemplate).toBeCalledWith(expectedDeployment);
                        return [2 /*return*/];
                }
            });
        }); });
        it("deploys ARM template from well-known (default) configuration", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, site;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        slsService.provider["armTemplate"] = null;
                        service = createService();
                        return [4 /*yield*/, service.deploy()];
                    case 1:
                        site = _a.sent();
                        expect(site).toEqual(expectedSite);
                        expect(armService_1.ArmService.prototype.createDeploymentFromConfig).not.toBeCalled();
                        expect(armService_1.ArmService.prototype.createDeploymentFromType).toBeCalledWith(armTemplates_1.ArmTemplateType.Consumption);
                        expect(armService_1.ArmService.prototype.deployTemplate).toBeCalledWith(expectedDeployment);
                        return [2 /*return*/];
                }
            });
        }); });
        it("deploys ARM template from well-known configuration", function () { return __awaiter(_this, void 0, void 0, function () {
            var service, site;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        slsService.provider["armTemplate"] = null;
                        slsService.provider["type"] = "premium";
                        service = createService();
                        return [4 /*yield*/, service.deploy()];
                    case 1:
                        site = _a.sent();
                        expect(site).toEqual(expectedSite);
                        expect(armService_1.ArmService.prototype.createDeploymentFromConfig).not.toBeCalled();
                        expect(armService_1.ArmService.prototype.createDeploymentFromType).toBeCalledWith(armTemplates_1.ArmTemplateType.Premium);
                        expect(armService_1.ArmService.prototype.deployTemplate).toBeCalledWith(expectedDeployment);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    it("uploads functions to function app and blob storage", function () { return __awaiter(_this, void 0, void 0, function () {
        var scmDomain, expectedUploadUrl, service, expectedArtifactName, uploadCall;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    scmDomain = app.enabledHostNames.find(function (hostname) { return hostname.endsWith("scm.azurewebsites.net"); });
                    expectedUploadUrl = "https://" + scmDomain + "/api/zipdeploy/";
                    service = createService();
                    return [4 /*yield*/, service.uploadFunctions(app)];
                case 1:
                    _a.sent();
                    expect(functionAppService_1.FunctionAppService.prototype.sendFile).toBeCalledWith({
                        method: "POST",
                        uri: expectedUploadUrl,
                        json: true,
                        headers: {
                            Authorization: "Bearer " + variables["azureCredentials"].tokenCache._entries[0].accessToken,
                            Accept: "*/*",
                            ContentType: "application/octet-stream",
                        }
                    }, slsService["artifact"]);
                    expectedArtifactName = service.getDeploymentName().replace("rg-deployment", "artifact");
                    expect(azureBlobStorageService_1.AzureBlobStorageService.prototype.uploadFile).toBeCalledWith(slsService["artifact"], config_1.default.deploymentConfig.container, expectedArtifactName + ".zip");
                    uploadCall = (azureBlobStorageService_1.AzureBlobStorageService.prototype.uploadFile).mock.calls[0];
                    expect(uploadCall[2]).toMatch(/.*-t([0-9]+)/);
                    return [2 /*return*/];
            }
        });
    }); });
    it("uploads functions to function app and blob storage with default naming convention", function () { return __awaiter(_this, void 0, void 0, function () {
        var scmDomain, expectedUploadUrl, sls, service, defaultArtifact, expectedArtifactName, uploadCall;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    scmDomain = app.enabledHostNames.find(function (hostname) { return hostname.endsWith("scm.azurewebsites.net"); });
                    expectedUploadUrl = "https://" + scmDomain + "/api/zipdeploy/";
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    delete sls.service["artifact"];
                    service = createService(sls);
                    return [4 /*yield*/, service.uploadFunctions(app)];
                case 1:
                    _a.sent();
                    defaultArtifact = path_1.default.join(".serverless", sls.service.getServiceName() + ".zip");
                    expect(functionAppService_1.FunctionAppService.prototype.sendFile).toBeCalledWith({
                        method: "POST",
                        uri: expectedUploadUrl,
                        json: true,
                        headers: {
                            Authorization: "Bearer " + variables["azureCredentials"].tokenCache._entries[0].accessToken,
                            Accept: "*/*",
                            ContentType: "application/octet-stream",
                        }
                    }, defaultArtifact);
                    expectedArtifactName = service.getDeploymentName().replace("rg-deployment", "artifact");
                    expect(azureBlobStorageService_1.AzureBlobStorageService.prototype.uploadFile).toBeCalledWith(defaultArtifact, config_1.default.deploymentConfig.container, expectedArtifactName + ".zip");
                    uploadCall = (azureBlobStorageService_1.AzureBlobStorageService.prototype.uploadFile).mock.calls[0];
                    expect(uploadCall[2]).toMatch(/.*-t([0-9]+)/);
                    return [2 /*return*/];
            }
        });
    }); });
    it("uploads functions with custom SCM domain (aka App service environments)", function () { return __awaiter(_this, void 0, void 0, function () {
        var customApp, expectedUploadUrl, service;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    customApp = __assign({}, mockFactory_1.MockFactory.createTestSite("CustomAppWithinASE"), { enabledHostNames: [
                            "myapi.customase.p.azurewebsites.net",
                            "myapi.scm.customase.p.azurewebsites.net"
                        ] });
                    expectedUploadUrl = "https://" + customApp.enabledHostNames[1] + "/api/zipdeploy/";
                    service = createService();
                    return [4 /*yield*/, service.uploadFunctions(customApp)];
                case 1:
                    _a.sent();
                    expect(functionAppService_1.FunctionAppService.prototype.sendFile).toBeCalledWith({
                        method: "POST",
                        uri: expectedUploadUrl,
                        json: true,
                        headers: {
                            Authorization: "Bearer " + variables["azureCredentials"].tokenCache._entries[0].accessToken,
                            Accept: "*/*",
                            ContentType: "application/octet-stream",
                        }
                    }, slsService["artifact"]);
                    return [2 /*return*/];
            }
        });
    }); });
    it("uses default name when no artifact provided", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, service;
        return __generator(this, function (_a) {
            sls = mockFactory_1.MockFactory.createTestServerless();
            delete sls.service["artifact"];
            service = createService(sls);
            expect(service.getFunctionZipFile()).toEqual(path_1.default.join(".serverless", sls.service.getServiceName() + ".zip"));
            return [2 /*return*/];
        });
    }); });
    it("uses package param from options if provided", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, options, service;
        return __generator(this, function (_a) {
            sls = mockFactory_1.MockFactory.createTestServerless();
            options = mockFactory_1.MockFactory.createTestServerlessOptions({
                package: "fake.zip",
            });
            service = createService(sls, options);
            expect(service.getFunctionZipFile()).toEqual("fake.zip");
            return [2 /*return*/];
        });
    }); });
});
