"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var axios_mock_adapter_1 = __importDefault(require("axios-mock-adapter"));
var mockFactory_1 = require("../test/mockFactory");
var invokeService_1 = require("./invokeService");
jest.mock("@azure/arm-appservice");
jest.mock("@azure/arm-resources");
jest.mock("./functionAppService");
var functionAppService_1 = require("./functionAppService");
describe("Invoke Service ", function () {
    var app = mockFactory_1.MockFactory.createTestSite();
    var expectedSite = mockFactory_1.MockFactory.createTestSite();
    var testData = "test-data";
    var testResult = "test-data";
    var authKey = "authKey";
    var baseUrl = "https://management.azure.com";
    var masterKeyUrl = "https://" + app.defaultHostName + "/admin/host/systemkeys/_master";
    var authKeyUrl = "" + baseUrl + app.id + "/functions/admin/token?api-version=2016-08-01";
    var urlPOST = "http://" + app.defaultHostName + "/api/hello";
    var urlGET = "http://" + app.defaultHostName + "/api/hello?name%3D" + testData;
    var masterKey;
    beforeAll(function () {
        var axiosMock = new axios_mock_adapter_1.default(axios_1.default);
        // Master Key
        axiosMock.onGet(masterKeyUrl).reply(200, { value: masterKey });
        // Auth Key
        axiosMock.onGet(authKeyUrl).reply(200, authKey);
        //Mock url for GET
        axiosMock.onGet(urlGET).reply(200, testResult);
        //Mock url for POST
        axiosMock.onPost(urlPOST).reply(200, testResult);
    });
    beforeEach(function () {
        functionAppService_1.FunctionAppService.prototype.getMasterKey = jest.fn();
        functionAppService_1.FunctionAppService.prototype.get = jest.fn(function () { return Promise.resolve(expectedSite); });
    });
    it("Invokes a function with GET request", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, options, expectedResult, httpConfig, service, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    options = mockFactory_1.MockFactory.createTestServerlessOptions();
                    expectedResult = { url: app.defaultHostName + "/api/hello" };
                    httpConfig = jest.fn(function () { return expectedResult; });
                    functionAppService_1.FunctionAppService.prototype.getFunctionHttpTriggerConfig = httpConfig;
                    options["function"] = "hello";
                    options["data"] = "{\"name\": \"" + testData + "\"}";
                    options["method"] = "GET";
                    service = new invokeService_1.InvokeService(sls, options);
                    return [4 /*yield*/, service.invoke(options["method"], options["function"], options["data"])];
                case 1:
                    response = _a.sent();
                    expect(JSON.stringify(response.data)).toEqual(JSON.stringify(testResult));
                    return [2 /*return*/];
            }
        });
    }); });
    it("Invokes a function with POST request", function () { return __awaiter(_this, void 0, void 0, function () {
        var sls, options, expectedResult, httpConfig, service, response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    sls = mockFactory_1.MockFactory.createTestServerless();
                    options = mockFactory_1.MockFactory.createTestServerlessOptions();
                    expectedResult = { url: app.defaultHostName + "/api/hello" };
                    httpConfig = jest.fn(function () { return expectedResult; });
                    functionAppService_1.FunctionAppService.prototype.getFunctionHttpTriggerConfig = httpConfig;
                    options["function"] = "hello";
                    options["data"] = "{\"name\": \"" + testData + "\"}";
                    options["method"] = "POST";
                    service = new invokeService_1.InvokeService(sls, options);
                    return [4 /*yield*/, service.invoke(options["method"], options["function"], options["data"])];
                case 1:
                    response = _a.sent();
                    expect(JSON.stringify(response.data)).toEqual(JSON.stringify(testResult));
                    return [2 /*return*/];
            }
        });
    }); });
});
