"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var mock_fs_1 = __importDefault(require("mock-fs"));
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var packageService_1 = require("./packageService");
var mockFactory_1 = require("../test/mockFactory");
describe("Package Service", function () {
    var sls;
    var packageService;
    var functionRoute = "myRoute";
    beforeEach(function () {
        sls = mockFactory_1.MockFactory.createTestServerless();
        sls.config.servicePath = process.cwd();
        sls.service["functions"] = {
            hello: mockFactory_1.MockFactory.createTestAzureFunctionConfig(functionRoute),
        };
        packageService = new packageService_1.PackageService(sls, mockFactory_1.MockFactory.createTestServerlessOptions());
    });
    afterEach(function () {
        mock_fs_1.default.restore();
    });
    it("cleans up function.json and function folders", function () { return __awaiter(_this, void 0, void 0, function () {
        var fsConfig, functionNames, unlinkSpy, rmdirSpy;
        return __generator(this, function (_a) {
            fsConfig = {};
            functionNames = sls.service.getAllFunctions();
            functionNames.forEach(function (functionName) {
                fsConfig[functionName] = {
                    "function.json": "contents",
                };
            });
            mock_fs_1.default(fsConfig);
            unlinkSpy = jest.spyOn(fs_1.default, "unlinkSync");
            rmdirSpy = jest.spyOn(fs_1.default, "rmdirSync");
            packageService.cleanUp();
            expect(unlinkSpy).toBeCalledTimes(functionNames.length);
            expect(rmdirSpy).toBeCalledTimes(functionNames.length);
            unlinkSpy.mockRestore();
            rmdirSpy.mockRestore();
            return [2 /*return*/];
        });
    }); });
    it("cleans up function.json but does not delete function folder", function () { return __awaiter(_this, void 0, void 0, function () {
        var fsConfig, functionNames, unlinkSpy, rmdirSpy;
        return __generator(this, function (_a) {
            fsConfig = {};
            functionNames = sls.service.getAllFunctions();
            functionNames.forEach(function (functionName) {
                fsConfig[functionName] = {
                    "function.json": "contents",
                    "index.js": "contents",
                };
            });
            mock_fs_1.default(fsConfig);
            unlinkSpy = jest.spyOn(fs_1.default, "unlinkSync");
            rmdirSpy = jest.spyOn(fs_1.default, "rmdirSync");
            packageService.cleanUp();
            expect(unlinkSpy).toBeCalledTimes(functionNames.length);
            expect(rmdirSpy).not.toBeCalled();
            unlinkSpy.mockRestore();
            rmdirSpy.mockRestore();
            return [2 /*return*/];
        });
    }); });
    it("createBinding writes function.json files into function folder", function () { return __awaiter(_this, void 0, void 0, function () {
        var functionName, functionMetadata, expectedFolderPath, expectedFilePath, expectedFunctionJson, mkdirSpy, writeFileSpy, call;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    functionName = "hello";
                    functionMetadata = {
                        entryPoint: "handler",
                        handlerPath: "src/handlers/hello",
                        params: {
                            functionsJson: {
                                bindings: [
                                    mockFactory_1.MockFactory.createTestHttpBinding("out"),
                                    mockFactory_1.MockFactory.createTestHttpBinding("in"),
                                ]
                            }
                        },
                    };
                    expectedFolderPath = path_1.default.join(sls.config.servicePath, functionName);
                    expectedFilePath = path_1.default.join(expectedFolderPath, "function.json");
                    expectedFunctionJson = {
                        entryPoint: "handler",
                        scriptFile: "src/handlers/hello",
                        bindings: [
                            mockFactory_1.MockFactory.createTestHttpBinding("out"),
                            __assign({}, mockFactory_1.MockFactory.createTestHttpBinding("in"), { route: functionRoute })
                        ]
                    };
                    mock_fs_1.default({});
                    mkdirSpy = jest.spyOn(fs_1.default, "mkdirSync");
                    writeFileSpy = jest.spyOn(fs_1.default, "writeFileSync");
                    return [4 /*yield*/, packageService.createBinding(functionName, functionMetadata)];
                case 1:
                    _a.sent();
                    expect(mkdirSpy).toBeCalledWith(expectedFolderPath);
                    call = writeFileSpy.mock.calls[0];
                    expect(call[0]).toEqual(expectedFilePath);
                    expect(JSON.parse(call[1])).toEqual(expectedFunctionJson);
                    mkdirSpy.mockRestore();
                    writeFileSpy.mockRestore();
                    return [2 /*return*/];
            }
        });
    }); });
    it("createBinding does not need to create directory if function folder already exists", function () { return __awaiter(_this, void 0, void 0, function () {
        var functionName, functionMetadata, expectedFolderPath, expectedFilePath, mkdirSpy, writeFileSpy;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    functionName = "hello";
                    functionMetadata = {
                        entryPoint: "handler",
                        handlerPath: "src/handlers/hello",
                        params: {
                            functionsJson: {
                                bindings: [
                                    mockFactory_1.MockFactory.createTestHttpBinding("out"),
                                    mockFactory_1.MockFactory.createTestHttpBinding("in"),
                                ]
                            },
                        },
                    };
                    expectedFolderPath = path_1.default.join(sls.config.servicePath, functionName);
                    expectedFilePath = path_1.default.join(expectedFolderPath, "function.json");
                    mock_fs_1.default({
                        "hello": {
                            "index.js": "contents",
                        },
                    });
                    sls.utils.dirExistsSync = jest.fn(function () { return true; });
                    mkdirSpy = jest.spyOn(fs_1.default, "mkdirSync");
                    writeFileSpy = jest.spyOn(fs_1.default, "writeFileSync");
                    return [4 /*yield*/, packageService.createBinding(functionName, functionMetadata)];
                case 1:
                    _a.sent();
                    expect(mkdirSpy).not.toBeCalledWith(expectedFolderPath);
                    expect(writeFileSpy).toBeCalledWith(expectedFilePath, expect.any(String));
                    mkdirSpy.mockRestore();
                    writeFileSpy.mockRestore();
                    return [2 /*return*/];
            }
        });
    }); });
    it("webpack copies required", function () { return __awaiter(_this, void 0, void 0, function () {
        var destinationPath, mkDirSpy, copyFileSpy;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    mock_fs_1.default({
                        // Generated by webpack plugin
                        ".webpack": {
                            "serivce": {}
                        },
                        // Generated by azure package plugin
                        "host.json": "contents",
                        "hello": {
                            "function.json": "contents",
                        },
                        "goodbye": {
                            "function.json": "contents",
                        },
                    });
                    destinationPath = path_1.default.join(".webpack", "service");
                    mkDirSpy = jest.spyOn(fs_1.default, "mkdirSync");
                    copyFileSpy = jest.spyOn(fs_1.default, "copyFileSync");
                    return [4 /*yield*/, packageService.prepareWebpack()];
                case 1:
                    _a.sent();
                    expect(copyFileSpy).toBeCalledWith("host.json", path_1.default.join(destinationPath, "host.json"));
                    sls.service.getAllFunctions().forEach(function (functionName) {
                        var functionJsonFilePath = path_1.default.join(functionName, "function.json");
                        expect(copyFileSpy).toBeCalledWith(functionJsonFilePath, path_1.default.join(destinationPath, functionJsonFilePath));
                    });
                    mkDirSpy.mockRestore();
                    copyFileSpy.mockRestore();
                    return [2 /*return*/];
            }
        });
    }); });
});
